/*  $Id: zip_64_end_of_central_directory_locator.cpp,v 1.4 2003/07/20 22:30:53 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Core/precomp.h"
#include "zip_64_end_of_central_directory_locator.h"
#include "API/Core/IOData/inputsource.h"
#include "API/Core/IOData/outputsource.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_64EndOfCentralDirectoryLocator construction:

CL_Zip_64EndOfCentralDirectoryLocator::CL_Zip_64EndOfCentralDirectoryLocator()
{
	signature = 0x07064b50;
}
	
CL_Zip_64EndOfCentralDirectoryLocator::~CL_Zip_64EndOfCentralDirectoryLocator()
{
}

/////////////////////////////////////////////////////////////////////////////	
// CL_Zip_64EndOfCentralDirectoryLocator attributes:


/////////////////////////////////////////////////////////////////////////////
// CL_Zip_64EndOfCentralDirectoryLocator operations:

void CL_Zip_64EndOfCentralDirectoryLocator::load(CL_InputSource *input)
{
	signature = input->read_int32();
	if (signature != 0x07064b50)
	{
		throw CL_Error("Incorrect Zip64 End of central directory locator signature!");
	}
	
	number_of_disk_with_zip64_end_of_central_directory = input->read_int32();
	relative_offset_of_zip64_end_of_central_directory = input->read_int64();
	total_number_of_disks = input->read_int32();
}
	
void CL_Zip_64EndOfCentralDirectoryLocator::save(CL_OutputSource *output)
{
	output->write_int32(signature);
	output->write_int32(number_of_disk_with_zip64_end_of_central_directory);
	output->write_int64(relative_offset_of_zip64_end_of_central_directory);
	output->write_int32(total_number_of_disks);
}

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_64EndOfCentralDirectoryLocator implementation:

